Package oracle.kv.pubsub

# Class NoSQLPublisherConfig

java.lang.Object
oracle.kv.pubsub.NoSQLPublisherConfig

public class NoSQLPublisherConfig extends Object
Configuration used to create an instance of NoSQLPublisher. User need to specify

- an instance of KVStoreConfig
- a path to a writable directory to create the publisher root directory.

In addition, user can also specify

- shard timeout in milliseconds, which represents a warning threshold of time that NoSQLPublisher does not hear from a shard. If a subscription does not hear from a shard for more than this threshold, a ShardTimeoutException will be signaled via NoSQLSubscriber.onWarn;
- maximum concurrent subscriptions, which represents a upper bound of the maximum number of concurrent subscriptions the publisher can support.

For secure store, user need to specify

- login credentials which will be used to authenticate with NoSQL DB
- a reauthentication handler which will be used to re-authenticate with the NoSQL DB.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `NoSQLPublisherConfig.Builder`
  Builder to help construct a NoSQLPublisherConfig instance

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `allowPreexistDir()`
  Returns true if pre-exist directory is allowed
  `boolean`
  `equals(Object obj)`
  `String[]`
  `getHelperHosts()`
  Gets the list of source kvstore helper hosts
  `int`
  `getMaxConcurrentSubs()`
  Gets the maximum number of concurrent subscriptions supported by this publisher.
  `String`
  `getPublisherId()`
  Returns the publisher id, or null if not set
  `String`
  `getRootPath()`
  Gets the root directory of the publisher
  `long`
  `getShardTimeoutMs()`
  Gets the configured shard timeout in ms
  `String`
  `getStoreName()`
  Gets the source kvstore name
  `int`
  `hashCode()`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### getStoreName

    public String getStoreName()
    Gets the source kvstore name
    Returns:
      the source kvstore name

  - ### getHelperHosts

    public String[] getHelperHosts()
    Gets the list of source kvstore helper hosts
    Returns:
      the list of source kvstore helper hosts

  - ### getShardTimeoutMs

    public long getShardTimeoutMs()
    Gets the configured shard timeout in ms
    Returns:
      the configured shard timeout in ms

  - ### getMaxConcurrentSubs

    public int getMaxConcurrentSubs()
    Gets the maximum number of concurrent subscriptions supported by this publisher.
    Returns:
      the maximum number of concurrent subscriptions

  - ### getRootPath

    public String getRootPath()
    Gets the root directory of the publisher
    Returns:
      the root directory

  - ### allowPreexistDir

    public boolean allowPreexistDir()
    Returns true if pre-exist directory is allowed
    Returns:
      true if pre-exist directory is allowed
    Since:
      19.5

  - ### getPublisherId

    public String getPublisherId()
    Returns the publisher id, or null if not set
    Returns:
      the publisher id, or null if not set
    Since:
      19.5

  - ### equals

    public boolean equals(Object obj)
    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `Object`